; References :

; http://cboard.cprogramming.com/windows-programming/42441-something-do-painting.html
; http://www.programmingcookbook.com/programming/mfc/note.html
; http://www.microsoft.com/msj/0197/c/c0197.aspx

.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\gdi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\gdi32.lib

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data

DlgBox db 'DLGBOX',0
capt   db 'Centered caption',0

.code

start:

    invoke  GetModuleHandle,0
    invoke  DialogBoxParam,eax,ADDR DlgBox,0,ADDR DlgProc,0
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL hDC:DWORD
LOCAL rc :RECT

    .IF uMsg==WM_NCPAINT

        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        invoke  GetClientRect,hWnd,ADDR rc
        mov     rc.top,7
        invoke  GetWindowDC,hWnd
        mov     hDC,eax
        invoke  GetSysColor,COLOR_ACTIVECAPTION	
        invoke  SetBkColor,hDC,eax
        invoke  GetSysColor,COLOR_CAPTIONTEXT	
        invoke  SetTextColor,hDC,eax
        invoke  DrawText,hDC,ADDR capt,-1,ADDR rc,DT_CENTER
        invoke  ReleaseDC,hWnd,hDC

    .ELSEIF uMsg==WM_NCACTIVATE

        .IF !wParam

            invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
            invoke  GetClientRect,hWnd,ADDR rc
            mov     rc.top,7
            invoke  GetWindowDC,hWnd
            mov     hDC,eax
            invoke  GetSysColor,COLOR_INACTIVECAPTION
            invoke  SetBkColor,hDC,eax
            invoke  GetSysColor,COLOR_INACTIVECAPTIONTEXT	
            invoke  SetTextColor,hDC,eax
            invoke  DrawText,hDC,ADDR capt,-1,ADDR rc,DT_CENTER
            invoke  ReleaseDC,hWnd,hDC
            mov     eax,1
            ret

        .ENDIF

    .ELSEIF uMsg==WM_CLOSE

        invoke  EndDialog,hWnd,0

    .ELSE

        xor     eax,eax
        ret

    .ENDIF

    mov     eax,1
    ret

DlgProc ENDP

END start

